
static char    *SccsId = "@(#)chars.c 1.1 5/25/92 CNM-US; C source";

/************************************************************************

Copyright (c) 1992 Juan D. Martin
Copyright (c) 1992 Centro Nacional de Microelectronica
Copyright (c) 1992 Universidad de Sevilla

Permission to use, copy, modify, distribute, and sell this software and
its documentation for any purpose is hereby granted without fee,
provided that (i) the above copyright notices and this permission
notice appear in all copies of the software and related documentation,
and (ii) the names of Centro Nacional de Microelectronica and
Universidad de Sevilla may not be used in any advertising or publicity
relating to the software without the specific, prior written
permission.

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

IN NO EVENT SHALL THE AUTHOR, CENTRO NACIONAL DE MICROELECTRONICA OR
UNIVERSIDAD DE SEVILLA BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT
OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

************************************************************************/
#include <stdio.h>
#include <X11/Xlib.h>
#include "xbdfdump.h"

unsigned        index_to_encoding(i)
unsigned        i;
{
    int             b1;
    int             b2;
    int             d;

    if (fontIsTwoByte)
    {
	d = fontMax2 - fontMin2 + 1;
	b1 = i / d + fontMin1;
	b2 = i % d + fontMin2;
	return ((b1 << 8) | b2);
    }
    else
    {
	return i + fontMin2;
    }
}

/* Draw a char with its top left at (x, y) */
void            draw_char(c, x, y, l, t)
unsigned        c;
int             x;
int             y;
int             l;
int             t;
{
    char            s;
    XChar2b         s2;
    unsigned        enc;

    enc = index_to_encoding(c);
    if (fontIsTwoByte)
    {
	s2.byte1 = enc >> 8;
	s2.byte2 = enc & 0xFF;
	XDrawString16(theDisplay, (Drawable) thePixmap, theGC,
		      x - l, y + t, &s2, 1);
    }
    else
    {
	s = (char) enc;
	XDrawString(theDisplay, (Drawable) thePixmap, theGC,
		    x - l, y + t, &s, 1);
    }
}

/* Write the bitmap out of a piece of XImage. */
void            scan_char(ximage, x, y, w, h)
XImage         *ximage;
unsigned        x;
unsigned        y;
unsigned        w;
unsigned        h;
{
    int             i,
                    j;
    int             bcnt,
                    code;

    /* This could be optimized... */
    for (i = y; i < y + h; i++)
    {
	code = 0;
	for (bcnt = 0, j = x; j < x + w; bcnt++, j++)
	{
	    if (XGetPixel(ximage, j, i))
	    {
		code |= (1 << (7 - bcnt % 8));
	    }
	    if (bcnt % 8 == 7)
	    {
		fprintf(theFile, "%02x", code);
		code = 0;
	    }
	}
	if (bcnt % 8 != 0)
	{
	    fprintf(theFile, "%02x", code);
	}
	putc('\n', theFile);
    }
}
