.\"
.\"@(#)xbdfdump.man 1.1 5/25/92 CNM-US; manual page
.\"
.\"Copyright (c) 1992 Juan D. Martin
.\"Copyright (c) 1992 Centro Nacional de Microelectronica
.\"Copyright (c) 1992 Universidad de Sevilla
.\"
.\"Permission to use, copy, modify, distribute, and sell this software and
.\"its documentation for any purpose is hereby granted without fee,
.\"provided that (i) the above copyright notices and this permission
.\"notice appear in all copies of the software and related documentation,
.\"and (ii) the names of Centro Nacional de Microelectronica and
.\"Universidad de Sevilla may not be used in any advertising or publicity
.\"relating to the software without the specific, prior written
.\"permission.
.\"
.\"THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
.\"EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
.\"WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
.\"
.\"IN NO EVENT SHALL THE AUTHOR, CENTRO NACIONAL DE MICROELECTRONICA OR
.\"UNIVERSIDAD DE SEVILLA BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT
.\"OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
.\"RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
.\"THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
.\"OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
.\"
.TH XBDFDUMP 1 "May 21 1992" "X Version 11"
.SH NAME
xbdfdump \- dump a font from an X server in BDF format
.sp
.SH SYNOPSIS
.B xbdfdump
[-display \fIdisplayname\fP] [-format \fIformatsfile\fP] [\fIfontname\fP
[\fIfilename\fP ...]
.SH DESCRIPTION
The \fIxbdfdump\fP program reads fonts from an X server and generates
BDF files that may be used to recreate the fonts.  This is useful for
reproducing lost BDF files and debugging purposes.  Each \fIfontname\fP
is dumped into \fIfilename\fP with BDF format. If no file is specified
for a font, then standard output is used. If there is no \fIfontname\fP
argument in the command line, \fBxbdfdump\fP attempts to read the file
\fBfonts.dir\fP in the current directory and dump, if possible, each
font described in \fBfonts.dir\fP changing its file extension to
".bdf". See \fBmkfontdir(1)\fP for a description of \fBfonts.dir\fP.
.br
.sp
The type of data associated to each property in the font is read from
\fIformatsfile\fP, or a default one if no one is supplied (usually
/usr/lib/X11/fonts/properties.fmt depending on the installation).  Each
line in this file contains either a comment (starting with \fI"#"\fP)
or a property name followed by a format surrounded by double quotes.
Formats follow the usual \fBprintf(3)\fP notation. Thus a line like:
.br
.sp
\fBFAMILY_NAME "%s"\fP
.br
.sp
sets the format of \fBFAMILY_NAME\fP to string, whereas:
.br
.sp
\fBCAP_HEIGHT "%u"\fP
.br
.sp
sets the format of \fBCAP_HEIGHT\fP to unsigned integer.  If a property is
found in the font and its format is not known, \fBxbdfdump\fP will
issue a warning and attempt to guess its type, but the results are
likely to be wrong. The best solution is to edit the formats file to
add a new entry.
.sp
.SH OPTIONS
.TP 8
\fB\-display\fP | \fB\-d\fP \fIdisplayname\fP
Specifies the display from which the fonts should be read.
.TP 8
\fB\-format\fP | \fB\-fmt\fP | \fB\-f\fP \fIformatsfile\fP
Specifies the file from which font properties formats should be read.
.TP 8
\fB\-help\fP | \fB\-h\fP
Give a brief summary of the usage.
.TP 8
\fB\-v\fP
Output the version of the program.
.sp
.SH FILES
.PD 0
.TP 20
.B /usr/lib/X11/fonts/properties.fmt
Default font properties format file.
.sp
.SH SEE ALSO
fstobdf(1), xfd(1), xlsfonts(1), mkfontdir(1)
.sp
.SH COPYRIGHT
Copyright (c) 1992, Juan D. Martin
.br
Copyright (c) 1992, Centro Nacional de Microelectronica 
.br
Copyright (c) 1992, Universidad de Sevilla
.sp
.SH AUTHOR
Juan D. Martin (juando@cnm.us.es)
